{********************************************************}
{TBufferedFile 0.20                                      }
{CopyRight (C) - 2000 by Luis Rodrigues                  }
{                                                        }
{If you need to contact me by any reason e-mail me at:   }
{EMAIL:LFRodrigues@portugalmail.pt                       }
{********************************************************}

unit BufferedFile;

interface

uses SysUtils;


//FIXME:for now this class can only read or write to a file
//on a next release i will add Read/Write 
const
     FM_READONLY = 0;
     FM_WRITEONLY = 1;

type
    TBuf = array[0..MaxLongInt-1] of byte;
    //could also be TBuf = array[0..MaxLongInt-1] of byte;
    PBuf = ^TBuf;

    TBufferedFile = class
    private
       Op_File: File;

       buf: PBuf;
       bufsize: integer;         // actual size of the buffer
       bytes_read: integer;      // number of bytes read into the buffer
       bufpos: integer;
       //bufoffset: integer;       // actual buffer offset in file
       FFileName: string;

       BytesInMem: LongInt;
       fFileMode: Byte;


        function GetBufFilePos: integer;
    public
       procedure ResetBuffer;

       property Position: Longint read GetBufFilePos;
       property FileName: string read FFileName;

       constructor Create(const FileName: string; Mode: Byte; _bufsize: LongInt);
       destructor Destroy; override;

       function Read(var Buffer; Count: Longint): Longint;
       function Write(const Buffer; Count: Longint): Longint;
       function Seek(Offset: Longint; Origin: Word): Longint;



    end;

implementation

//in readmode the file must exist, in write mode if it doesnt exist we create it
constructor TBufferedFile.Create(const FileName: string; Mode: Byte; _bufsize: LongInt);
begin
     AssignFile(Op_File, Filename);
     if ((Mode = FM_READONLY) or (Mode = FM_WRITEONLY)) and FileExists(Filename) then
        Reset(Op_File,1)
     else
         if (Mode = FM_WRITEONLY) and (not FileExists(Filename)) then
            ReWrite(Op_File,1)
     else //error --> readonly and not fileexists
         raise Exception.Create('Could not open file.');

     bufsize := _bufsize;
     BufPos := 0;
     bytes_read := 0;
     //bufoffset := 0;
     fFileName := FileName;
     FileMode := Mode;
     fFileMode := Mode;
     GetMem(buf, bufsize);
     FillChar(Buf^, BufSize, 0);
end;

destructor TBufferedFile.Destroy;
begin
     if fFileMode = FM_WRITEONLY then //if we were writting to the file lets clean the buffer
        ResetBuffer;
     Freemem(buf);
     CloseFile(Op_File);
end;

procedure TBufferedFile.ResetBuffer;
begin
    if BufPos > 0 then //if there's anyting in the buffer lets clean it
       BlockWrite(Op_File, Buf^[0], BufPos);
    BufPos := 0;
    Bytes_Read := 0;
end;

//FIXME: This rotine is supost to be used with small values in count and the value
//in count must be smaller than MaxLongInt
function TBufferedFile.Read(var Buffer; Count: LongInt): Longint;
var HelpIndex: LongInt;
    TmpBuffer: PBuf;
begin                        
     if fFileMode = FM_WRITEONLY then
        begin
             Result := 0;
             Exit;
        end;
     HelpIndex := 0;
     Result := 0;
       //the buf is zero based array
     //if bufpos >= bytes_read-1 then
     if bufpos >= bytes_read then
        begin
             BlockRead(Op_File, Buf^[0],bufsize,bytes_read);
             BytesInMem := bytes_read;
             BufPos := 0;
             if bytes_read = 0 then
                begin
                     //Pointer(Buffer) := nil;
                     Result := 0;
                     exit;
                end;
        end;
     if Count > BytesInMem then //if the user is asking for more bytes that are in mem
        begin
             GetMem(TmpBuffer,Count);
             //copies the ones that are in mem
             Move(Buf^[bufPos],TmpBuffer^[0], BytesInMem);
             Result := Result + BytesInMem;
             count := count - BytesInMem;
             HelpIndex := BytesInMem;
             while count > 0 do  
             begin
                  //loads some more --> reloads the buffer
                  BlockRead(Op_File, Buf^[0],bufsize,bytes_read);
                  //if we are at the end of the file;
                  if bytes_read = 0 then break;
                  //-
                  BytesInMem := bytes_read;
                  //copies some more --> from buffer into tmpbuffer
                  if count > BytesInMem then
                     begin
                          Move(Buf^[0],TmpBuffer^[HelpIndex],BytesInMem);
                          Count := Count - BytesInMem;
                          Result := Result + BytesInMem;
                          HelpIndex := HelpIndex + BytesInMem;
                     end
                  else
                      begin
                           Move(Buf^[0],TmpBuffer^[HelpIndex],Count);
                           BytesInMem := BytesInMem - Count;
                           Result := Result + Count;
                           HelpIndex := HelpIndex + Count;
                           bufpos := Count;
                           Count := 0;
                      end;
             end;
             Move(TmpBuffer^[0], Buffer,HelpIndex); //if the file hasn't ended helpindex = count
        end
     else //if the user is asking for less bytes that are in mem
         begin
              Move(Buf^[bufPos],Buffer, Count);
              bufpos := bufpos + Count;
              BytesInMem := BytesInMem - Count;
              Result := Result +  Count;
         end;
end;

function TBufferedFile.Write(const Buffer; Count: LongInt): Longint;
var HelpIndex: Integer;
    TmpBuffer: PBuf;
begin
     HelpIndex := 0;
     if fFileMode = FM_READONLY then
        begin
             Result := 0;
             Exit;
        end;
    // if bufPos = bufsize-1 then //if the buffer is full
     //--<if bufPos-1 >= bufsize then //if the buffer is full
      if bufPos >= bufsize then //if the buffer is full
        begin
             BlockWrite(Op_File, Buf^[0], BufSize);
             BufPos := 0;
        end;
     if Count > (BufSize - (BufPos)) then //if we have to write more chars that are left on the buffer
        begin
             GetMem(TmpBuffer, Count);
             Move(Buffer, TmpBuffer^[0], Count);
             //fill the rest of the buffer
             Move(TmpBuffer^[0], Buf^[BufPos], BufSize-BufPos);
             HelpIndex := HelpIndex + (BufSize-BufPos);
             Count := Count - (BufSize-BufPos);
             //clear it
             BlockWrite(Op_File, Buf^[0], BufSize);
             BufPos := 0;
             while Count > 0 do //while there's still bytes left on buffer var ge them
             begin
                  if Count > BufSize then
                     begin
                          Move(TmpBuffer^[HelpIndex],Buf^[0], BufSize);
                          BlockWrite(Op_File, Buf^[0], BufSize);
                          HelpIndex := HelpIndex + BufSize;
                          Count := Count - BufSize;
                     end
                  else
                      begin
                           Move(TmpBuffer^[HelpIndex],Buf^[0], Count);
                           //BlockWrite(File_Op, Buf^[0], BufSize);
                           HelpIndex := HelpIndex + Count;
                           BufPos := Count;
                           Count := Count - Count;
                      end;
             end;
        end
     else  //if we want to write less chars that are left on buffer
         begin
              Move(Buffer, Buf^[BufPos], Count);
              BufPos := BufPos + Count;
              HelpIndex := Count;

         end;
     Result := HelpIndex;
end;

function TBufferedFile.GetBufFilePos: Longint;
begin
     if fFileMode = FM_READONLY then
        Result := FilePos(Op_File) - bytes_read + BufPos; //Result := PositionOfFile - BytesReadLastTime + PositionOfBuffer
     if fFileMode = FM_WRITEONLY then
        Result := FilePos(Op_File) + BufPos; //Result := PositionOfFile  + PositionOfBuffer

end;

function TBufferedFile.Seek(Offset: Longint; Origin: Word): Longint;
var
   BufferPieceToGo, PosToStartRead, BufInc: LongInt;
begin
     {
      contas: -- i've not tested these avalues very well some of them might be wrong 
      pos div bufsiz = buffertogo
      if pos mod bufsiz <> 0 then buffertogo++
      buffertogo--
      buffertogo * bufsize+1 = postostartread
      postogo - postostartred = bufincremento
     }
     Result := Self.Position; //just in case the user wants a offset that doens exist we stay where we are
     if fFileMode = FM_WRITEONLY then //if are writting then lets empty the buffer
        ResetBuffer;

     BufferPieceToGo := Offset div bufsize;
     if (Offset mod bufsize) <> 0 then Inc(BufferPieceToGo);
     Dec(BufferPieceToGo); //--lets make the buffers a 0 based array

     PosToStartRead := BufferPieceToGo * bufsize;
     if PosToStartRead > FileSize(Op_File) then //if the user wants to go to a aofsset that doesn't exist get out
        exit;
     BufInc := Offset - PosToStartRead;
     //now that i've calculated the needed values lets go to that position
     System.Seek(Op_File,PosToStartRead);
     BlockRead(Op_File,Buf^[0], bufsize, bytes_read);
     //update the vars so they reflect the new pos
     BufPos := BufInc;
     BytesInMem := Bytes_Read - BufPos;

     Result := Offset;
     //if we are writing we have to resurn Bufsize bytes back so that
     //when we write the data we replace the one with has been read
     if fFileMode = FM_WRITEONLY then
        System.Seek(Op_File, FilePos(Op_File) - BufSize);
end;

end.
